# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://www.teamviewer.com/en/download/windows/"
    download_dict = {
        "windows-x64": "https://download.teamviewer.com/download/TeamViewer_Setup_x64.exe",
        "windows-x86": "https://download.teamviewer.com/download/TeamViewer_Setup.exe",
        "darwin-all": "https://download.teamviewer.com/download/TeamViewer.dmg",
    }
    download_url = download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]]
    latest_bin = download_url.split("/")[-1]

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "div", "class", "cmp-downloadlist__version-info", proxies=proxies):
        if "Current version" in bs_search.text:
            version = bs_search.text.split(": ")[1].split("\n")[0]
            break

    # Deleting binaries
    for f in glob.glob("*.exe") :
        if Version(get_version_from_binary(latest_bin)) < Version(version):
            print("Removing: %s" % f)
            remove_file(f)

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)

    # Checking version from file
    version_from_file = get_version_from_binary(latest_bin)

    control.set_software_version(version_from_file)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

